package com.example.syncfusion.gauge_androidnative;

import android.graphics.Color;
import android.graphics.PointF;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.widget.LinearLayout;

import com.syncfusion.gauges.SfCircularGauge.Header;
import com.syncfusion.gauges.SfCircularGauge.CircularPointer;
import com.syncfusion.gauges.SfCircularGauge.CircularScale;
import com.syncfusion.gauges.SfCircularGauge.NeedlePointer;
import com.syncfusion.gauges.SfCircularGauge.RangePointer;
import com.syncfusion.gauges.SfCircularGauge.SfCircularGauge;
import com.syncfusion.gauges.SfCircularGauge.TickSetting;
import com.syncfusion.gauges.SfCircularGauge.enums.NeedleType;

import java.util.ArrayList;




public class MainActivity extends AppCompatActivity {

    SfCircularGauge circularGauge;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        circularGauge = new SfCircularGauge(this);
        LinearLayout mLinearLayout = new LinearLayout(this);
        mLinearLayout.setBackgroundColor(Color.TRANSPARENT);
        mLinearLayout.addView(circularGauge);

        LinearLayout.LayoutParams mBarParams=new LinearLayout.LayoutParams(LinearLayout.LayoutParams.MATCH_PARENT, LinearLayout.LayoutParams.WRAP_CONTENT);
        mBarParams.setMargins(220, 280, 30, 30);
        mBarParams.height=500;
        mBarParams.width=300;
        mLinearLayout.setLayoutParams(mBarParams);

        circularGauge.setBackgroundColor(Color.TRANSPARENT);
        ArrayList<CircularScale> _circularScales = new ArrayList<CircularScale>();
        ArrayList<CircularPointer> _circularPointers = new ArrayList<CircularPointer>();
        ArrayList<Header> _gaugeHeaders = new ArrayList<Header>();

        // adding  new CircularScale
        CircularScale circularScale = new CircularScale();
        circularScale.setStartValue(0);
        circularScale.setEndValue(100);
        circularScale.setStartAngle(130);
        circularScale.setSweepAngle(280);
        circularScale.setRimWidth(15);
        circularScale.setRimColor(Color.parseColor("#D14646"));
        circularScale.setMinorTicksPerInterval(0);
        circularScale.setLabelOffset(0.1);
        circularScale.setLabelColor(Color.WHITE);
        circularScale.setLabelTextSize(18);
        //circularScale.setRadiusFactor(0.5);

        //adding major ticks
        TickSetting majorTicksSettings = new TickSetting();
        majorTicksSettings.setColor(Color.WHITE);
        majorTicksSettings.setSize(15);
        majorTicksSettings.setOffset(0.07);
        circularScale.setMajorTickSettings(majorTicksSettings);

        //adding minor ticks
        TickSetting minorTicksSettings = new TickSetting();
        minorTicksSettings.setColor(Color.GRAY);
        circularScale.setMinorTickSettings(minorTicksSettings);

        // adding needle Pointer
        NeedlePointer needlePointer = new NeedlePointer();
        needlePointer.setValue(70);
        needlePointer.setKnobColor(Color.parseColor("#2BBFB8"));
        needlePointer.setKnobRadius(20);
        needlePointer.setType(NeedleType.Triangle);
        needlePointer.setLengthFactor(0.8);
        needlePointer.setWidth(10);
        needlePointer.setColor(Color.GRAY);
        _circularPointers.add(0, needlePointer);

        // adding range Pointer
        RangePointer rangePointer = new RangePointer();
        rangePointer.setValue(70);
        rangePointer.setColor(Color.parseColor("#2BBFB8"));
        rangePointer.setWidth(15);
        _circularPointers.add(1, rangePointer);

        circularScale.setCircularPointers(_circularPointers);
        _circularScales.add(0, circularScale);

        circularGauge.setCircularScales(_circularScales);

        LinearLayout mainLayout = new LinearLayout(this);
        mainLayout.setOrientation(LinearLayout.VERTICAL);
        mainLayout.setBackgroundResource(R.drawable.bg);
        mainLayout.addView(mLinearLayout);

        setContentView(mainLayout);

    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings) {
            return true;
        }

        return super.onOptionsItemSelected(item);
    }
}
